<template>
  <main class="content container">
    <div class="content__top content__top--catalog">
      <h1 class="content__title">
        Каталог
      </h1>
      <span class="content__info">
        152 товара
      </span>
    </div>

    <div class="content__catalog">

      <ProductFilter
        v-model:price-from="filterPriceFrom"
        v-model:price-to="filterPriceTo"
        v-model:categoryID="filterCategoryId"
        v-model:productColor="filterColor">
      </ProductFilter>

      <section class="catalog">
        <ProductList :products="product"></ProductList>
        <BasePagination v-model="page" :count="countProducts" :per-page="productsPerPage">
        </BasePagination>
      </section>
    </div>
  </main>
</template>

<script>
import products from './data/products';
import ProductList from './components/ProductList.vue';
import BasePagination from './components/BasePagination.vue';
import ProductFilter from './components/ProductFilter.vue';

export default {
  components: { ProductList, BasePagination, ProductFilter },
  name: 'App',
  data() {
    return {
      page: 1,
      productsPerPage: 3,
      products,
      filterPriceFrom: 0,
      filterPriceTo: 0,
      filterCategoryId: 0,
      filterColor: null,
    };
  },
  computed: {
    filteredProducts() {
      let filteredProducts = products;

      if (this.filterPriceFrom > 0) {
        filteredProducts = filteredProducts.filter(
          (product) => product.price >= this.filterPriceFrom,
        );
      }

      if (this.filterPriceTo > 0) {
        filteredProducts = filteredProducts.filter(
          (product) => product.price <= this.filterPriceTo,
        );
      }

      if (this.filterCategoryId) {
        filteredProducts = filteredProducts.filter(
          (product) => product.categoryID === this.filterCategoryId,
        );
      }

      if (this.filterColor) {
        filteredProducts = filteredProducts.filter(
          (product) => product.colors.includes(this.filterColor),
        );
      }

      return filteredProducts;
    },
    product() {
      const offset = (this.page - 1) * this.productsPerPage;
      return this.filteredProducts.slice(offset, offset + this.productsPerPage);
    },
    countProducts() {
      return this.filteredProducts.length;
    },
  },
};
</script>
